OpenSSL Montgomery Multiplication Denial of Service Vulnerability (Windows)

2017-02-09T00:00:00
ID OPENVAS:1361412562310810543
Type openvas
Reporter Copyright (C) 2017 Greenbone Networks GmbH
Modified 2017-10-24T00:00:00

Description

This host is running OpenSSL and is prone to denial of service vulnerability.

                                        
                                            ###############################################################################
# OpenVAS Vulnerability Test
# $Id: gb_openssl_montgomery_multiplication_dos_vuln_win.nasl 7543 2017-10-24 11:02:02Z cfischer $
#
# OpenSSL Montgomery Multiplication Denial of Service Vulnerability (Windows)
#
# Authors:
# Rinu Kuriakose <krinu@secpod.com>
#
# Copyright:
# Copyright (C) 2017 Greenbone Networks GmbH, http://www.greenbone.net
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 2
# (or any later version), as published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
###############################################################################

CPE = "cpe:/a:openssl:openssl";

if(description)
{
  script_oid("1.3.6.1.4.1.25623.1.0.810543");
  script_version("$Revision: 7543 $");
  script_cve_id("CVE-2016-7055");
  script_bugtraq_id(94242);
  script_tag(name:"cvss_base", value:"2.6");
  script_tag(name:"cvss_base_vector", value:"AV:N/AC:H/Au:N/C:N/I:N/A:P");
  script_tag(name:"last_modification", value:"$Date: 2017-10-24 13:02:02 +0200 (Tue, 24 Oct 2017) $");
  script_tag(name:"creation_date", value:"2017-02-09 18:50:03 +0530 (Thu, 09 Feb 2017)");
  script_tag(name:"qod_type", value:"remote_banner");
  script_name("OpenSSL Montgomery Multiplication Denial of Service Vulnerability (Windows)");

  script_tag(name:"summary", value:"This host is running OpenSSL and is prone
  to denial of service vulnerability.");

  script_tag(name:"vuldetect", value:"Get the installed version with the help
  of detect NVT and check the version is vulnerable or not.");

  script_tag(name:"insight", value:"The flaw is due to a carry propagating 
  bug in the Broadwell-specific Montgomery multiplication procedure that 
  handles input lengths divisible by, but longer than 256 bits.");

  script_tag(name:"impact", value:"Successful exploitation will allow a remote
  attacker to cause transient authentication, key negotiation failures or 
  reproducible erroneous outcome of public-key operations with specially 
  crafted input and also denial of service condition.

  Impact Level: Application");

  script_tag(name:"affected", value:"OpenSSL 1.1.0 before 1.1.0c and 
  1.0.2 before 1.0.2k on Windows.");

  script_tag(name:"solution", value:"Upgrade to OpenSSL version 1.1.0c or 
  1.0.2k or later. For updates refer to https://www.openssl.org");

  script_tag(name:"solution_type", value:"VendorFix");

  script_xref(name : "URL" , value : "https://www.openssl.org/news/secadv/20170126.txt");
  script_xref(name : "URL" , value : "https://www.openssl.org/news/secadv/20161110.txt");

  script_category(ACT_GATHER_INFO);
  script_copyright("Copyright (C) 2017 Greenbone Networks GmbH");
  script_family("Denial of Service");
  script_dependencies("gb_openssl_detect.nasl", "os_detection.nasl");
  script_mandatory_keys("OpenSSL/installed", "Host/runs_windows");
  script_require_ports("Services/www", 80);
  exit(0);
}

include("host_details.inc");
include("version_func.inc");

## Variable Initialization
sslVer = "";
fix = "";
sslPort = 0;

## Get Port
if(!sslPort = get_app_port(cpe:CPE)){
  exit(0);
}

## Get Version
if(!sslVer = get_app_version(cpe:CPE, port:sslPort)){
  exit(0);
}

## Checking for Vulnerable version
if(sslVer =~ "^(1\.1\.0)"){
  fix = "1.1.0c";
}

else if(sslVer =~ "^(1\.0\.2)"){
  fix = "1.0.2k";
}

if(!fix) exit(99);

if(version_is_less(version:sslVer, test_version:fix))
{
  report = report_fixed_ver(installed_version:sslVer, fixed_version:fix);
  security_message(port:sslPort, data:report);
  exit(0);
}

exit(99);